Subject: bug#46469: 27.1; `isearch-del-char' should move point further back

From: Juri Linkov <[email-masked]>
Date: Sun, 14 Feb 2021 19:45:37 +0200

>> Anyway isearch-fallback in your patch does nothing.  Maybe you intended
>> to use isearch-pop-state, but this what isearch-delete-char already does.
>
> Please rest assured that the patch works, or at least works in all test
> cases I could come up with.  It implements the behavior I described in
> detail in my third message in this thread.
>
> Put in another way, the patch makes ‘C-s y DEL x’ pretty much equivalent
> to ‘C-s y☺\|x’, where DEL stands for `isearch-del-char' and ☺ stands for
> an unmatchable regexp.

I tried again, but your patch still doesn't work.  With

(progn
  (define-key isearch-mode-map (kbd "DEL") 'isearch-del-char)
  (execute-kbd-macro [?\C-s ?y backspace ?x ?1]))
x1yx2

It signals the error "Keyboard macro terminated by a command ringing the bell".